          .z80
	  .radix 16
	  ld a,0e2
	  ld (0f3e0),a
          db 0f7,0,6f,0
          ld c,9
          ld de,str
          call 5
          ld hl,slot
          ld bc,200  
	  ld de,8000
          ldir
str:      db 'S C R E E N   1$'
          jp 8000
slot:     .phase 8000
          ld a,0f0
          out (0a8),a
          ld hl,data
          ld de,3800
          ld bc,20
          call 5c
          ld hl,atrb0
          ld de,1b00
          ld bc,4
          call 5c
begin:    ld a,0
          call 0d5
s3:       cp 3
          jr nz,s7
          ld hl,1b01
          call 4a
          inc a
          cp 0ff
          jr nz,e3
          dec a
e3:       call 4d
          jp wen
s7:       cp 7
          jr nz,s1
          ld hl,1b01
          call 4a
          dec a
          cp 0
          jr nz,e7
          inc a
e7:       call 4d
          jp wen
s1:       cp 1
          jr nz,s5
          ld hl,1b00
          call 4a
          dec a
          cp 0
          jr nz,e1
          inc a
e1:       call 4d
          jp wen
s5:       cp 5
          jr nz,s2
          ld hl,1b00
          call 4a
          inc a
          cp 0b8
          jr nz,e5
          dec a
e5:       call 4d
          jp wen
s2:       cp 2
          jr nz,s4
          ld hl,1b00
          call 4a
          dec a
          cp 0
          jr nz,s02
          inc a
s02:      call 4d
          ld hl,1b01
          call 4a
          inc a
          cp 0ff
          jr nz,s12
          dec a
s12:      call 4d
          jp wen
s4:       cp 4
          jr nz,s6
          ld hl,1b00
          call 4a
          inc a
          cp 0b8
          jr nz,s04
          dec a
s04:      call 4d
          ld hl,1b01
          call 4a
          inc a
          cp 0ff
          jr nz,s14
          dec a
s14:      call 4d
          jp wen
s6:       cp 6
          jr nz,s8
          ld hl,1b00
          call 4a
          inc a
          cp 0b8
          jr nz,s06
          dec a
s06:      call 4d
          ld hl,1b01
          call 4a
          dec a
          cp 0
          jr nz,s16
          inc a
s16:      call 4d
          jp wen
s8:       cp 8
          jr nz,wen
          ld hl,1b00
          call 4a
          dec a
          cp 0
          jr nz,s08
          inc a
s08:      call 4d
          ld hl,1b01
          call 4a
          dec a
          cp 0
          jr nz,s18
          inc a
s18:      call 4d
wen:      ld a,(0fbeb)
          cp 0fb
          jr nz,wend
          ld hl,1b03
          call 4a
          dec a
          cp 0ff
          jr nz,col
          ld a,0f
col:      call 4d

          ld hl,1000
prol1:    ld a,h
          dec hl
          or l
          jr nz,prol1
wend:     ld hl,200
prol:     ld a,h
          dec hl
          or l
          jr nz,prol
          call 0b7
      	  jr c,the_end
          jp begin
the_end:  ld a,0ff
          out (0a8),a
          rst 0
atrb0:    db 30,30,0,0f
          .radix 2
data:     10000000
          01100000
          01011000
          00110100
          00101010
          00010101
          00001010
          00000101
          00000010
          00000001
          0,0,0,0,0,0,0,0,0,0,0,0
          10000000
          01000000
          10100000
          01010000
          10101000
          01010100
          00101100
          00011000
          00000000
          00000000
          end
