	.Z80
	.RADIX	16
ADDIR	EQU	8000
NO	EQU	2C6
	DB	0F7,0,41,0
	LD	HL,I1
	LD	DE,9800
	LD	BC,200
	LDIR
	LD	A,0C3
	LD	HL,INSERT
	LD	(0F24F),A
	LD	(0F250),HL
	LD	HL,ADDIR
	LD	(FIRST),HL
	LD	HL,DATA1
	LD	BC,0A
	LD	DE,ADDIR
	LDIR
	LD	A,50
	LD	(0F3B0),A
	LD	HL,0A00
	LD	BC,0FA
	XOR	A
	DB	0F7,0,56,0
	LD	BC,01F0C
	DB	0F7,0,47,0     ;vdp(13)=F4
	LD	BC,0F00D
	DB	0F7,0,47,0     ;vdp(14)=F0
	DB	0F7,0,0CC,0
	LD	C,9
	LD	HL,0A11
	LD	A,0FE
	DB	0F7,0,4D,0
	LD	HL,0A2F
	LD	A,0FE
	DB	0F7,0,4D,0
	LD	DE,DATA0
	CALL	5
	LD	A,'t'
	LD	HL,50*1A-1
	DB	0F7,0,4D,0
	DB	0F7,0,44,0
	LD	HL,ADDIR
	LD	BC,0A
	LD	DE,0AFA
	DB	0F7,0,5C,0
	LD	HL,ADDIR
;--------------- LEFT --------------------
LEFT:	CALL	CLS
	LD	HL,ADDIR
	LD	(FILE),HL
	LD	(FIRST),HL
	LD	HL,0A0B
	LD	A,18
	DB	0F7,0,4D,0
	LD	HL,0A0E
	XOR	A
	DB	0F7,0,4D,0
	CALL	CLEAR
	CALL	DIRECTA
	LD	HL,ADDIR
	LD	(FILE),HL
	LD	HL,0A1E
	LD	A,07F
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FE
	DB	0F7,0,4D,0
	DEC	HL
KURSL:	PUSH	HL
	XOR	A
	DB	0F7,0,0D5,0
	POP	HL
	LD	BC,0A
	CP	3
	JP	Z,RIGHT
	CP	1
	JP	NZ,DOWNL
	LD	A,L
	CP	1E
	JP	Z,UZADL
	XOR	A
	DB	0F7,0,4D,0
	XOR	A
	INC	HL
	DB	0F7,0,4D,0
	DEC	HL
	SBC	HL,BC
	LD	A,07F
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	DEC	HL
	PUSH	HL
	LD	HL,(FILE)
	LD	DE,0020
	SBC	HL,DE
	LD	(FILE),HL
	POP	HL
	JP	ZADL
UZADL:	PUSH	HL
	LD	HL,(FIRST)
	LD	A,H
	CP	80
	JR	NZ,USEUPL
	LD	HL,8020
	LD	(FIRST),HL
	LD	(FILE),HL
USEUPL:	LD	BC,0020
	SBC	HL,BC
	LD	(FIRST),HL
	LD	HL,(FILE)
	LD	DE,0020
	SBC	HL,DE
	LD	(FILE),HL
	POP	HL
	JP	ZADL
DOWNL:	CP	5
	JP	NZ,ZADL
	LD	A,L
	CP	0C8
	JP	Z,DZADL
	XOR	A
	DB	0F7,0,4D,0
	XOR	A
	INC	HL
	DB	0F7,0,4D,0
	DEC	HL
	ADD	HL,BC
	LD	A,07F
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	DEC	HL
	PUSH	HL
	LD	HL,(FILE)
	LD	DE,0020
	ADD	HL,DE
	LD	(FILE),HL
	POP	HL
	JP	ZADL
DZADL:	PUSH	HL
	LD	HL,(FIRST)
	LD	A,H       ;ZAP
	CP	8B
	JR	NZ,USEDOWL
	LD	A,L
	CP	0C0
	JR	NZ,USEDOWL
	LD	HL,8BA0
	LD	(FIRST),HL
	LD	(FILE),HL ;ZAP
USEDOWL:LD	BC,0020
	ADD	HL,BC
	LD	(FIRST),HL
	LD	HL,(FILE)
	LD	DE,0020
	ADD	HL,DE
	LD	(FILE),HL
	POP	HL
;--------  ZADL  ----------
ZADL:	PUSH	HL
	LD	HL,(FIRST)
	CALL	PRINTL
	DB	0F7,0,0B7,0
	JP	C,TEND
	POP	HL
	JP	KURSL
TEND:   LD	A,0C9
	LD	(0F24F),A
	RST	0
;---------  RIGHT  -----------
RIGHT:	CALL	CLS
	LD	HL,ADDIR
	LD	(FILE),HL
	LD	(FIRST),HL
	LD	HL,0A0E
	LD	A,0C
	DB	0F7,0,4D,0
	LD	HL,0A0B
	XOR	A
	DB	0F7,0,4D,0
	CALL	CLEAR
	CALL	DIRECTB
	LD	HL,ADDIR
	LD	(FILE),HL
	LD	HL,0A21
	LD	A,03F
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	DEC	HL
KURSR:	PUSH	HL
	XOR	A
	DB	0F7,0,0D5,0
	POP	HL
	LD	BC,0A
	CP	7
	JP	Z,LEFT
	CP	1
	JP	NZ,DOWNR
	LD	A,L
	CP	21
	JP	Z,UZADR
	XOR	A
	DB	0F7,0,4D,0
	XOR	A
	INC	HL
	DB	0F7,0,4D,0
	DEC	HL
	SBC	HL,BC
	LD	A,03F
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	DEC	HL
	PUSH	HL
	LD	HL,(FILE)
	LD	DE,0020
	CP	H
	JR	Z,SLUP
	SBC	HL,DE
SLUP:	LD	(FILE),HL
	POP	HL
	JP	ZADR
UZADR:	PUSH	HL
	LD	HL,(FIRST)
	LD	A,H
	CP	80
	JR	NZ,USEUPR
	LD	HL,8020
	LD	(FIRST),HL
	LD	(FILE),HL
USEUPR:	LD	BC,0020
	SBC	HL,BC
	LD	(FIRST),HL
	LD	HL,(FILE)
	LD	DE,0020
	SBC	HL,DE
	LD	(FILE),HL
	POP	HL
	JP	ZADR
DOWNR:	CP	5
	JP	NZ,ZADR
	LD	A,L
	CP	0CB
	JP	Z,DZADR
	XOR	A
	DB	0F7,0,4D,0
	XOR	A
	INC	HL
	DB	0F7,0,4D,0
	DEC	HL
	ADD	HL,BC
	LD	A,03F
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	DEC	HL
	PUSH	HL
	LD	HL,(FILE)
	LD	DE,0020
	ADD	HL,DE
	LD	(FILE),HL
	POP	HL
	JP	ZADR
DZADR:	PUSH	HL
	LD	HL,(FIRST)
	LD	A,H       ;ZAP
	CP	8B
	JR	NZ,USEDOWR
	LD	A,L
	CP	0C0
	JR	NZ,USEDOWR
	LD	HL,8BA0
	LD	(FIRST),HL
	LD	(FILE),HL ;ZAP
USEDOWR:LD	BC,0020
	ADD	HL,BC
	LD	(FIRST),HL   ;KEY 1 0DF
	LD	HL,(FILE)
	LD	DE,20
	ADD	HL,DE
	LD	(FILE),HL
	POP	HL
;--------  ZADR  ----------
ZADR:	PUSH	HL
	LD	HL,(FIRST)
	CALL	PRINTR
	DB	0F7,0,0B7,0
	JP	C,TEND
	LD	(0FBEB),A       ; KEYBOARD
	LD	BC,0
	PUSH	BC
	POP	AF
	CPL
	BIT	5,A
	CALL	Z,DELETE        ;KEY 1
	POP	HL
	JP	KURSR
;-------------- SUBROTINE READ DIRECTORY a: -----
DIRECTA:LD	HL,ADDIR        ; 
	LD	(0F23D),HL
	XOR	A
	LD	(0F2E1),A
	LD	C,2F
	LD	DE,7
	LD	HL,700
	CALL	5            ; 
	DB	0F7,87,1F,40	;. .
	RET
;-------------- SUBROTINE READ DIRECTORY B: -----
DIRECTB:LD	HL,ADDIR        ; 
	LD	(0F23D),HL
	LD	A,01
	LD	(0F2E1),A
	LD	C,2F
	LD	DE,7
	LD	HL,701
	CALL	5            ; 
	DB	0F7,87,1F,40	;. .
	RET
;----------- SUBROTINE PRINTL DIRECTORY -------
PRINTL:	PUSH	HL
	LD	HL,(FILE)
	LD	A,(HL)
	CP	''
	JR 	Z,WYH
	CP	' '
	JR 	Z,WYH
	OR	A
	JR 	Z,WYH
	LD	BC,08
	LD	DE,6E6
	DB	0F7,0,5C,0
	LD	BC,8
	LD	DE,6EF
	LD	HL,(FILE)
	ADD	HL,BC
	LD	BC,3
	DB	0F7,0,5C,0
	LD	A,'.'	
	LD	HL,6EE
	DB	0F7,0,4D,0
WYH:	POP	HL
	LD	BC,08
	LD	DE,0F2
	LD	A,12
	PUSH	AF
	PUSH	BC
	PUSH	HL
	PUSH	DE
DIRA:	PUSH	AF
	DB	0F7,0,5C,0
	POP	AF
	POP	DE
	POP	HL
	PUSH	HL
	PUSH	DE
	PUSH	AF
	LD	BC,8
	ADD	HL,BC
	EX	DE,HL
	LD	BC,9
	ADD	HL,BC
	EX	DE,HL
	LD	BC,3
	DB	0F7,0,5C,0
	POP	AF
	LD	HL,0050
	POP	DE
	ADD	HL,DE
	EX	DE,HL
	LD	BC,20
	POP	HL
	ADD	HL,BC
	POP	BC
	POP	AF
	DEC	A
	PUSH	AF
	PUSH	BC
	PUSH	HL
	PUSH	DE
	JR 	NZ,DIRA
	POP	AF
	POP	HL
	POP	AF
	POP	AF
	RET
;----------- SUBROTINE PRINTR DIRECTORY -------
PRINTR:	PUSH	HL
	LD	HL,(FILE)
	LD	A,(HL)
	CP	''
	JR	Z,WYHR
	CP	' '
	JR	Z,WYHR
	OR	A
	JR	Z,WYHR
	LD	BC,08  ;
	LD	DE,6FF
	DB	0F7,0,5C,0
	LD	BC,8
	LD	DE,708
	LD	HL,(FILE)
	ADD	HL,BC
	LD	BC,3
	DB	0F7,0,5C,0
	LD	A,'.'	
	LD	HL,707
	DB	0F7,0,4D,0
WYHR:	POP	HL
	LD	BC,08
	LD	DE,10B
	LD	A,12
	PUSH	AF
	PUSH	BC
	PUSH	HL
	PUSH	DE
DIRB:	PUSH	AF
	DB	0F7,0,5C,0
	POP	AF
	POP	DE
	POP	HL
	PUSH	HL
	PUSH	DE
	PUSH	AF
	LD	BC,8
	ADD	HL,BC
	EX	DE,HL
	LD	BC,9
	ADD	HL,BC
	EX	DE,HL
	LD	BC,3
	DB	0F7,0,5C,0
	POP	AF
	LD	HL,0050
	POP	DE
	ADD	HL,DE
	EX	DE,HL
	LD	BC,20
	POP	HL
	ADD	HL,BC
	POP	BC
	POP	AF
	DEC	A
	PUSH	AF
	PUSH	BC
	PUSH	HL
	PUSH	DE
	JR	NZ,DIRB
	POP	AF
	POP	HL
	POP	AF
	POP	AF
	RET
;------- SUBROTINE  TIME -------------
TIME:   PUSH	HL
	LD	C,2C
	CALL	5
	               ; H - , L - , D -
	POP	HL
	RET
;------ SUBROTINE CLEAR FON  ---------
CLEAR:	LD	HL,0A1C
	LD	BC,0FA-01C
	XOR	A
	DB	0F7,0,56,0
	LD	HL,0A2F
	LD	A,0FE
	DB	0F7,0,4D,0
	RET
;------- SUBROTINE INSERT DISK FOR DRIVE NAME -------
INSERT: CALL	0F36B
	CALL	FON1
	LD	C,9
	CP	'A'
	JR	NZ,FORB
	CALL	INS
	LD	A,'A'
	LD	HL,NO
	DB	0F7,0,4D,0
	LD	BC,0F80C
	DB	0F7,0,47,0
	CALL	STRIKE
	XOR	A
	LD	(0FCAF),A
	DB	0F7,0,56,1
	DB	0F7,0,9F,0
	LD	BC,01F0C
	DB	0F7,0,47,0
	JP	LEFT
FORB:	CALL	INS
	LD	A,'B'
	LD	HL,NO
	DB	0F7,0,4D,0
	LD	BC,0F80C
	DB	0F7,0,47,0
	CALL	STRIKE
	XOR	A
	LD	(0FCA9),A
	DB	0F7,0,56,1
	DB	0F7,0,9F,0
	LD	BC,01F0C
	DB	0F7,0,47,0
	JP	RIGHT
INS:    LD	DE,26A
	LD	HL,L01
	LD	BC,0F
	DB	0F7,0,5C,0
	LD	DE,2BB
	LD	HL,L02
	LD	BC,0E
	DB	0F7,0,5C,0
	RET
;---- STRIKE A KEY WHEN READY --
STRIKE:	LD	DE,3AB
	LD	BC,0C
	LD	HL,L03
	DB	0F7,0,5C,0
	LD	DE,3FB
	LD	BC,0C
	LD	HL,L04
	DB	0F7,0,5C,0
	CALL	FON2
	RET
;--- DISK OFFLINE --------------
OFFLINE:LD	DE,26A
	LD	HL,L05
	LD	BC,10
	DB	0F7,0,5C,0
	CALL	FON1
	CALL	STRIKE
	JP	LEFT
;--  DISK READ ERROR -----------
ERROR:	LD	DE,26A
	LD	HL,L06
	LD	BC,11
	DB	0F7,0,5C,0
	CALL	FON1
	CALL	STRIKE
	JP	LEFT
;----INVALID DRIVE SPECIFICATION --
DRIVE?:	LD	DE,26A
	LD	HL,L15
	LD	BC,0C
	DB	0F7,0,5C,0
	LD	DE,2BB
	LD	HL,L16
	LD	BC,0D
	DB	0F7,0,5C,0
	CALL	FON1
	JP	LEFT
;------  CLEAR MESSAGE ---------
CLS:	PUSH	HL
	PUSH	BC
	LD	HL,268
	LD	BC,15
	PUSH	AF
	XOR	A
	DB	0F7,0,56,0
	LD	HL,2B9
	LD	BC,15
	XOR	A
	DB	0F7,0,56,0
	LD	HL,3A9
	LD	BC,15
	XOR	A
	DB	0F7,0,56,0
	LD	HL,3F9
	LD	BC,15
	XOR	A
	DB	0F7,0,56,0
;------ CLS DOWN TEIL ----------------
CLSDM:	LD	HL,4E7
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,537
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,587
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,5D7
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,627
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,677
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,6C7
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	LD	HL,717
	LD	BC,17
	XOR	A
	DB	0F7,0,56,0
	POP	AF
	POP	BC
	POP	HL
	RET
;------ FON 1 -----------------
FON1:	PUSH	HL
	PUSH	AF
	PUSH	BC
	PUSH	DE
	LD	B,4
	LD	DE,7
	LD	HL,0A42
F1:	LD	A,3
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	ADD	HL,DE
	DJNZ	F1
	POP	DE
	POP	BC
	POP	AF
	POP	HL
	RET
FON2:	PUSH	HL
	PUSH	AF
	PUSH	BC
	PUSH	DE
	LD	B,4
	LD	DE,7
	LD	HL,0A42+0A*4
F2:	LD	A,3
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	ADD	HL,DE
	DJNZ	F2
	POP	DE
	POP	BC
	POP	AF
	POP	HL
	RET
FON3:	PUSH	HL
	PUSH	AF
	PUSH	BC
	PUSH	DE
	LD	B,0A
	LD	DE,7
	LD	HL,0A42+0A*8
F3:	LD	A,3
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	INC	HL
	LD	A,0FF
	DB	0F7,0,4D,0
	ADD	HL,DE
	DJNZ	F3
	POP	DE
	POP	BC
	POP	AF
	POP	HL
	RET
;------ DELETE -----------------
DELETE:	CALL	FON3
	LD	DE,4E9
	LD	HL,L0E
	LD	BC,7
	DB	0F7,0,5C,0
	CALL	STRIKE
	CALL	DIRECTA
	RET
;------RENAME-----------------
RENAME:	CALL	FON3
	LD	DE,4E9
	LD	HL,L0C
	LD	BC,5
	DB	0F7,0,5C,0
	CALL	STRIKE
	RET
;----- COPY ----------------
COPY:	CALL	FON3
	LD	DE,4E9
	LD	HL,L19
	LD	BC,5
	DB	0F7,0,5C,0
	CALL	STRIKE
	CALL	DIRECTA
	RET
;----- PROTECT -------------
PROTECT:CALL	FON3
	LD	DE,4E9
	LD	HL,L1B
	LD	BC,0F
	DB	0F7,0,5C,0
	CALL	STRIKE
	RET
;----- FORMAT --------------
FORMAT:	CALL	FON3
	LD	DE,4E9
	LD	HL,L07
	LD	BC,7
	DB	0F7,0,5C,0
	CALL	STRIKE
	RET
;----- Current time ---------
CTIME:	CALL	FON3
	LD	DE,4E9
	LD	HL,L10
	LD	BC,11
	DB	0F7,0,5C,0
	RET
;----- Current date --------
CDATE:	CALL	FON3
	LD	DE,4E9
	LD	HL,L11
	LD	BC,11
	DB	0F7,0,5C,0
	RET
;------- MESSAGE  --------------
I1:	.PHASE	9800
L01:	DB	'Insert diskette'
L02:	DB	'for drive " :"'
L03:	DB	'Strike a key'
L04:	DB	'when ready !'
L05:	DB	'Disk not ready !'
L06:	DB	'Disk read error !'
L07:	DB	'Format.'
L08:	DB	'Drive name ? (A,B)'
L09:	DB	'1- Double sided.'
L0A:	DB	'2- Single sided.'
L0B:	DB	'Format complete !'
L0C:	DB	'Name:'
L0D:	DB	'As:'
L0E:	DB	'Delete:'
L0F:	DB	'Are you sure ? (Y/N)'
L10:	DB	'Current new time:'
L11:	DB	'Current new date:'
L12:	DB	'Do you really'
L13:	DB	'want leave AC ?'
L14:	DB	'(Y/N)'
L15:	DB	'Invalid drive'
L16:	DB	'specification.'
L17:	DB	'bytes used.'
L18:	DB	'bytes free.'
L19:	DB	'Copy'
L1A:	DB	'Copy complete !'
L1B:	DB	'Write protect !'
	.DEPHASE
;-------------------------------
FIRST:	DS	02
FILE:	DS	02
DATA0:	DB	0C
	DB	'XWWWWWWWWWWWWWWWWWWWWWWWWRWWWWWWWWWWWWWWWWWWWWWWWWWWWY'
	DB	'XWWWWWWWWWWWWWWWWWWWWWWWY',0A,0D
	DB	'V   Drive "A:"           V   Drive "B:"              V'
	DB	'V Time:                 V',0D,0A
	DB	'TWWWWWWWWWWWWWWWWWWWWWWWWUWWWWWWWWWWWWWWWWWWWWWWWWWWWS'
	DB	'ZWWWWWWWWWWWWWWWWWWWWWWW[',0D,0A
	DB	'V         .              V         .                 V'
	DB	'XWWWWWWWWWWWWWWWWWWWWWWWY',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V Date:                 V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'ZWWWWWWWWWWWWWWWWWWWWWWW[',0D,0A
	DB	'V         .              V         .                 V'
	DB	'XWWWWWWWWWWWWWWWWWWWWWWWY',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'ZWWWWWWWWWWWWWWWWWWWWWWW[',0D,0A
	DB	'V         .              V         .                 V'
	DB	'XWWWWWWWWWWWWWWWWWWWWWWWY',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'ZWWWWWWWWWWWWWWWWWWWWWWW[',0D,0A
	DB	'V         .              V         .                 V'
	DB	'XWWWWWWWWWWWWWWWWWWWWWWWY',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'V         .              V         .                 V'
	DB	'V                       V',0D,0A
	DB	'TWWWWWWWWWWWWWWWWWWWWWWWWUWWWWWWWWWWWWWWWWWWWWWWWWWWWS'
	DB	'V                       V',0D,0A
	DB	'V A:\>                   V B:\>                      V'
	DB	'V                       V',0D,0A
	DB	'ZWWWWWWWWWWWWWWWWWWWWWWWWQWWWWWWWWWWWWWWWWWWWWWWWWWWW['
	DB	'ZWWWWWWWWWWWWWWWWWWWWWWW[',0D,0A
	DB	'       K i e v    Copyright by 1991  (C).    N.O.V.',0A,0D
	DB	'1 Del  2 Copy  3 Ren  4 Type  5 Start  6 Format  7 datE  8 tiMe  9 Help  10 Qui',0B,'$'
DATA1:	DB	0F9,0F9,0F3,0F3,0F9,0FE,07E,07E,07E,7F
	END
